<?php

/**
 * files actions.
 * 
 * @package    
 * @subpackage files
 * @developer  
 * @author     
 * @version    
 */
class filesActions extends sfActions
{
  public function executeIndex()
  {
    return $this->forward('files', 'list');
  }

  public function executeThumb()
  {
  	if($this->getUser()->getAttribute('thumbOnOff') == 'show')
			$this->getUser()->setAttribute('thumbOnOff', 'hide');
		else
			$this->getUser()->setAttribute('thumbOnOff', 'show');
		
    return $this->redirect($_SERVER['HTTP_REFERER']);
  }


  public function executeList()
  {
  	if($this->getRequestParameter('parent')){
			if(!is_numeric($this->getRequestParameter('parent')))
				$this->forward404();
			sfLoader::loadHelpers(array('Url', 'Tag'));
			$this->parent = $this->getRequestParameter('parent');

  		$this->category = skyGetRecordById('category',$this->getRequestParameter('parent'));
  		$this->forward404Unless($this->category);
  		$this->catName = $this->category->category_name;
		$this->catTitle = $this->category->title;
		$this->catLabel = $this->category->label;
		$this->catMusic = $this->category->music;
		$this->catDescription = $this->category->description;
		$this->catRemixer = $this->category->remixer;
		$this->catType = $this->category->type;
		if($this->catType=='A')
		$this->Title = ' Album Songs';
		else
		$this->Title = '';
		if(!$first_catName = myUser::parentsName($this->category->parentsarray,', ',true)){$first_catName="";}
		
		$uri=str_replace("/",' ',$_SERVER['REQUEST_URI']);
		if(preg_match("/new2old/i",$uri)){$t="New";}
		elseif(preg_match("/download/i",$uri)){$t="Top";}
		elseif(preg_match("/a2z/i",$uri)){$t="Best";}
		elseif(preg_match("/z2a/i",$uri)){$t="All";}

  		/*
  		* SKYiTech :: make category title and category path from parentsArray
  		*/
			$parentsArray = explode('||',$this->category->parentsarray);
			array_shift($parentsArray);
			$this->categoryPath = '';
			for($i = 0; $i<count($parentsArray); $i+=2){
				$this->categoryPath .= link_to($parentsArray[$i+1],'/category/list?parent='.$parentsArray[$i].'&fname='.myUser::slugify($parentsArray[$i+1])) . ' &raquo; ';
				$this->catTitle .= $parentsArray[$i+1].' > ';
			}
			$sql = 'select * from files where status!="B" and category_id='.$this->getRequestParameter('parent');
			$this->totalRecords = skyMysqlGetCount($sql);

			if($this->getRequestParameter('sort')=='download')
				$sql .= ' order by download desc';
			elseif($this->getRequestParameter('sort')=='new2old')
				$sql .= ' order by ord asc,id desc';
			elseif($this->getRequestParameter('sort')=='a2z')
				$sql .= ' order by file_name asc';
			elseif($this->getRequestParameter('sort')=='z2a')
				$sql .= ' order by file_name desc';

			$this->page = $this->getRequestParameter('page', 1);
			$startLimit = skyGetStartLimit($this->totalRecords, $this->page, SETTING_FILES_PER_PAGE);
			$sql .= ' limit '.$startLimit.','.SETTING_FILES_PER_PAGE;
	        $filess = skyMysqlQuery($sql);
	        
			$this->filess = array();
			while ($value = mysqli_fetch_object($filess)):
				$this->filess[]=$value;
			endwhile;
			$this->pageTitle = $this->catName.' - '.sfConfig::get('app_sitename');
		    $this->pageDescription = $this->catName.' Download - '.sfConfig::get('app_sitename');
		    $this->pageKeywords = $this->catName.', '.$first_catName.', '.$this->catName.' Mp3 Songs Download, '.$this->catName.' Gana Download, '.$this->catName.' Pagalworld, '.$this->catName.' Download, '.sfConfig::get('app_sitename');
		    
	        $this->getResponse()->setTitle($this->pageTitle);
	        $this->getResponse()->addMeta('description', $this->pageDescription);
	        $this->getResponse()->addMeta('keywords', $this->pageKeywords);
            // $thisUrl='/category/list?parent='.$this->parent.'&fname='.myUser::slugify($this->catName).'&sort='.$this->getRequestParameter('sort').'&page='.$this->page;
	        if($this->parents->child!='D' && $this->parents->child!='U' ){$thisUrl='/files/list?parent='.$this->parent.'&fname='.myUser::slugify($this->catName).'&sort='.$this->getRequestParameter('sort').'&page='.$this->page;}
		    $this->getResponse()->setCanonical($thisUrl);
	        unset($this->catTitle);

	  }
		else{
	    return $this->redirect('');
	  }
  }

  public function executeSinger()
  {
  	if($this->getRequestParameter('singer')){
            $singer_name = ucwords(myUser::dospace($this->getRequestParameter('singer')));
			$sql = 'select * from files where status!="B" and singer like "%'.$singer_name.'%"';
			$this->totalRecords = skyMysqlGetCount($sql);

			if($this->getRequestParameter('sort')=='download')
				$sql .= ' order by download desc';
			elseif($this->getRequestParameter('sort')=='new2old')
				$sql .= ' order by created_at desc';
			elseif($this->getRequestParameter('sort')=='a2z')
				$sql .= ' order by file_name asc';
			elseif($this->getRequestParameter('sort')=='z2a')
				$sql .= ' order by file_name desc';

			$this->page = $this->getRequestParameter('page', 1);
			$startLimit = skyGetStartLimit($this->totalRecords, $this->page, SETTING_FILES_PER_PAGE);
			$sql .= ' limit '.$startLimit.','.SETTING_FILES_PER_PAGE;
	    $filess = skyMysqlQuery($sql);
			$this->filess = array();
			while ($value = mysqli_fetch_object($filess)):
				$this->filess[]=$value;
			endwhile;
  		$this->catName = $singer_name.' Mp3 Songs Free Download';
	    $this->getResponse()->setTitle($singer_name.' Mp3 Songs Free Download - '.sfConfig::get('app_sitename'));
	    $this->getResponse()->addMeta('description', $singer_name.' Mp3 Songs Free Download - '.sfConfig::get('app_sitename'));
	    $this->getResponse()->addMeta('keywords', $singer_name.' Mp3 Songs Free Download - '.sfConfig::get('app_sitename'));
	    $this->getResponse()->setCanonical('@filesSingerList?singer='.myUser::slugify($singer_name).'&sort='.$this->getRequestParameter('sort').'&page='.$this->page);
  	}
  }
  
  public function executeFeatured()
  {
			//$c->setLimit(3);
			$sql = 'select * from files where status="F"';
			$this->totalRecords = skyMysqlGetCount($sql);
			$sql .= ' order by created_at desc';
			$this->page = $this->getRequestParameter('page', 1);
			$startLimit = skyGetStartLimit($this->totalRecords, $this->page, SETTING_FILES_PER_PAGE);
			$sql .= ' limit '.$startLimit.','.SETTING_FILES_PER_PAGE;
	        $filess = skyMysqlQuery($sql);

			$this->filess = array();
			while ($value = mysqli_fetch_object($filess)):
				$this->filess[]=$value;
			endwhile;
			$this->getResponse()->setTitle('Featured Files Download - '.sfConfig::get('app_sitename'));
	        $this->getResponse()->addMeta('description', 'Featured Files Download - '.sfConfig::get('app_sitename'));
	        $this->getResponse()->addMeta('keywords', 'Featured Files Download, '.sfConfig::get('app_sitename'));
	        $this->getResponse()->setCanonical('@featured?page='.$this->page);
  }
  public function executeAlbum()
  {
			$sql = 'select id, category_name, parentsarray, child, files, url from category where status="A" and type="A"';
			$this->totalRecords = skyMysqlGetCount($sql);
			$sql .= ' order by id desc';
			$this->page = $this->getRequestParameter('page', 1);
			$startLimit = skyGetStartLimit($this->totalRecords, $this->page, SETTING_CATEGORY_PER_PAGE);
			$sql .= ' limit '.$startLimit.','.SETTING_CATEGORY_PER_PAGE;
	        $category = skyMysqlQuery($sql);
			$this->category = array();
			while ($value = mysqli_fetch_object($category)):
				$this->category[]=$value;
			endwhile;
			$this->getResponse()->setTitle('Latest Albums - '.sfConfig::get('app_sitename'));
	        $this->getResponse()->addMeta('description', 'Latest Albums Download - '.sfConfig::get('app_sitename'));
	        $this->getResponse()->addMeta('keywords', 'Latest Albums Download, '.sfConfig::get('app_sitename'));
	        $this->getResponse()->setCanonical('@album?page='.$this->page);
  }

  public function executeLastadded()
  {
  	
  	if(SETTING_LATEST_FILES_LIST=='ON'){
			//$c->setLimit(3);
			$sql = 'select * from files where status!="B"';
			$this->totalRecords = skyMysqlGetCount($sql);
			$sql .= ' order by created_at desc';
			$this->page = $this->getRequestParameter('page', 1);
			$startLimit = skyGetStartLimit($this->totalRecords, $this->page, SETTING_FILES_PER_PAGE);
			$sql .= ' limit '.$startLimit.','.SETTING_FILES_PER_PAGE;
	        $filess = skyMysqlQuery($sql);
			$this->filess = array();
			while ($value = mysqli_fetch_object($filess)):
				$this->filess[]=$value;
			endwhile;
			$this->getResponse()->setTitle('New Added Files Download - '.sfConfig::get('app_sitename'));
	        $this->getResponse()->addMeta('keywords', 'New Added Files Download, Latest Mp3 Songs Download - '.sfConfig::get('app_sitename'));
	        $this->getResponse()->addMeta('keywords', 'New Added Files Download, Latest Mp3 Songs Download, '.sfConfig::get('app_sitename'));
	        $this->getResponse()->setCanonical('@lastAddedFiles?page='.$this->page);
		}
		else
			$this->redirect('/');
  }

  public function executeSearch()
  {
  	checkDB();
  	if($this->getRequestParameter('commit')=='Singer'){
  		if($this->getRequestParameter('find'))
	  		$this->redirect('artist/list?type=find&find='.$this->getRequestParameter('find'));
	  	else
	  		$this->redirect('artist/list');
  	}
  	if($this->getRequestParameter('commit')=='Album'){
  		$this->redirect('category/search?type=find&find='.$this->getRequestParameter('find'));
  	}
  	if($this->getRequestParameter('find')){

//  		$sql = 'select * from files where status!="B" and file_name like "%'.str_replace(' ','%',mysqlEscapeString(($this->getRequestParameter('find')))).'%"';
  		$sql = 'select files.*,category.category_name,category.parentsarray from files 
  		LEFT JOIN category ON category.id=files.category_id 
  		where files.status!="B" and 
  		(tags like "%'.str_replace(' ','%',mysqlEscapeString(($this->getRequestParameter('find')))).'%" OR singer like "%'.str_replace(' ','%',mysqlEscapeString(($this->getRequestParameter('find')))).'%") ';
//  		echo $sql = 'select id,file_name,category_id,size,download,description,extension,created_at from files where status!="B" and MATCH(tags) AGAINST ("*'.str_replace(' ','*',str_replace(' ','*',mysqlEscapeString(($this->getRequestParameter('find'))))).'*" IN BOOLEAN MODE)';
  		if($this->getRequestParameter('ext') && strtoupper($this->getRequestParameter('ext'))!='ALL')
  			$sql .= ' and extension="'. strtoupper(mysqlEscapeString($this->getRequestParameter('ext'))).'"';
  		if($this->getRequestParameter('cat') && strtoupper($this->getRequestParameter('cat'))!=0)
  			$sql .= ' and category_id IN (select id from category where parents like "|' .(mysqlEscapeString($this->getRequestParameter('cat'))). '|%")';
			$this->totalRecords = skyMysqlGetCount($sql,true);

			if($this->getRequestParameter('sort')=='download')
				$sql .= ' order by download desc';
			elseif($this->getRequestParameter('sort')=='a2z')
				$sql .= ' order by file_name asc';
			elseif($this->getRequestParameter('sort')=='z2a')
				$sql .= ' order by file_name desc';
			else
				$sql .= ' order by created_at desc';

			$this->page = $this->getRequestParameter('page', 1);
			$startLimit = skyGetStartLimit($this->totalRecords, $this->page, SETTING_FILES_PER_PAGE);
			$sql .= ' limit '.$startLimit.','.SETTING_FILES_PER_PAGE;
	    $this->filess = skyMysqlQuery($sql);

  		$this->catName = $this->getRequestParameter('find').' Your Search Result';
	    $this->getResponse()->setTitle($this->getRequestParameter('find').' - '.sfConfig::get('app_sitename'));
	  }
		else{
	    return $this->redirect('');
	  }
  }

//   public function executeTop()
//   {
//     if($this->getRequestParameter('type')=='today')
//     	$titleText = 'Today\'s';
//     elseif($this->getRequestParameter('type')=='yesterday')
//     	$titleText = 'Yesterday\'s';
//     elseif($this->getRequestParameter('type')=='week')
//     	$titleText = 'Last Week\'s';
//     elseif($this->getRequestParameter('type')=='month')
//     	$titleText = 'This Month\'s';
//     elseif($this->getRequestParameter('type')=='all')
//     	$titleText = 'All Time\'s';

// 		if($this->getRequestParameter('type')=='yesterday')
// 			$filess = DownloadHistoryPeer::getMostPopuler(1);
// 		elseif($this->getRequestParameter('type')=='week')
// 			$filess = DownloadHistoryPeer::getMostPopuler(7);
// 		elseif($this->getRequestParameter('type')=='month')
// 			$filess = DownloadHistoryPeer::getMostPopuler(date('j')-1);
// 		elseif($this->getRequestParameter('type')=='today')
// 			$filess = DownloadHistoryPeer::getMostPopuler(0);
// 		elseif($this->getRequestParameter('type')=='all')
// 			$filess = DownloadHistoryPeer::getMostPopuler(100);

// 		$this->filess = array();
// 		while ($value = mysqli_fetch_object($filess)):
// 			$this->filess[]=$value;
// 		endwhile;
		
// 		$this->getResponse()->setTitle($titleText.' Top Downloaded Files - '.sfConfig::get('app_sitename'));
//         $this->getResponse()->addMeta('description', $titleText.' Top Downloaded Files - '.sfConfig::get('app_sitename'));
//         $this->getResponse()->addMeta('keywords', $titleText.' Top Downloaded Files, '.sfConfig::get('app_sitename'));
//         $this->getResponse()->setCanonical('@topFiles?type='.$this->getRequestParameter('type'));
//   }

  public function executeShow()
  {
		sfLoader::loadHelpers(array('Url', 'Tag'));
		if(!is_numeric($this->getRequestParameter('id')))
			$this->forward404();
    $this->files = skyGetRecordById('files',$this->getRequestParameter('id'));
    $this->forward404Unless($this->files);

    /* SKYitech:: redirect to home if file not found */
    if(!$this->files || $this->files->status=='B')
    	$this->redirect('default','');
    	
 		$parent = skyGetRecordById('category',$this->files->category_id);
        $this->catName = $parent->category_name;
        $this->list_ord = $parent->list_ord;

		/*
		* SKYiTech :: make category title and category path from parentsArray
		*/
		$parentsArray = explode('||',$parent->parentsarray);
		array_shift($parentsArray);
		$this->categoryPath = '';
		if($parent->type=='A')
        $this->cType = 'Album';
        else
        $this->cType = 'Category';
        $this->fileMusic = $this->files->music;
        $this->fileSinger = $this->files->singer;
        $this->fileLabel = $this->files->label;
        $this->fileRemixer = $this->files->remixer;
        $this->fileEmbed = $this->files->embed;
		for($i = 0; $i<count($parentsArray); $i+=2){
			$this->categoryPath .= link_to($parentsArray[$i+1],'/category/list?parent='.$parentsArray[$i].'&fname='.myUser::slugify($parentsArray[$i+1])) . ' &raquo; ';
			$this->catTitle .= $parentsArray[$i+1].' > ';
		}
            $this->pageTitle = myUser::space(myUser::fileName($this->files->file_name,false)).' Mp3 Song Download - '.sfConfig::get('app_sitename');
		    $this->pageDescription = myUser::space(myUser::fileName($this->files->file_name,false)).' Mp3 Song Download, '.$this->catName.' Songs Download - '.sfConfig::get('app_sitename');
		    $this->pageKeywords = myUser::space(myUser::fileName($this->files->file_name,false)).' Mp3 Song Download, '.$this->catName.' Songs Download, '.myUser::space(myUser::fileName($this->files->file_name,false)).', '.sfConfig::get('app_sitename');
		    
	        $this->getResponse()->setTitle($this->pageTitle);
	        $this->getResponse()->addMeta('description', $this->pageDescription);
	        $this->getResponse()->addMeta('keywords', $this->pageKeywords);
	        $this->getResponse()->setCanonical('@filesShow?id='.$this->files->id.'&name='.myUser::slugify(myUser::space(myUser::fileName($this->files->file_name,false))));
            unset($this->catTitle);

/*
		$sql = "select id,file_name,category_id,extension,size,download from files where category_id=".$this->files->category_id.' order by rand() limit 3';
		$randomfiless = skyMysqlQuery($sql);
		$this->randomfiles = array();
		while ($value = mysqli_fetch_object($randomfiless)):
			$this->randomfiles[]=$value;
		endwhile;
*/
  }

	public function executeLimitover()
	{
	}

	public function executePermission()
	{
	}

	public function executeDisclaimer()
	{
	}

	public function executeAdvancesearch()
	{
	}
}
