<?php 

define('dbhost','localhost');
define('dbname','santavur_db');
define('dbuser','santavur_db');
define('dbpass','KCAr!4rf+xW9d%s');

if(phpversion() > 5.7) $mysqli=true;

function connectDB()
{
	global $conms;
  $conms = @mysqli_connect(dbhost,dbuser,dbpass); //connect mysql
  
  mysqli_set_charset($conms,'utf8');
  if(!$conms) return false;
  $condb = @mysqli_select_db($conms,dbname);
  if(!$condb) die('Can\' connect database '. mysqli_error());
  // echo '--connected--';
  return true;
}
function connectDBAdmin()
{
	global $conms;
  $conms = @mysqli_connect(dbhost,dbuser,dbpass); //connect mysql with master server
  if(!$conms) return false;
  $condb = @mysqli_select_db($conms,dbname);
  if(!$condb) die('Can\' connect database '. mysqli_error());
  // echo '--connected--';
  return true;
}

function checkDB()
{
	global $conms;
	if (!is_resource($conms))
  	connectDB();
  // echo '--dis-connected--';
}
function closeDB()
{
	global $conms;
	if (is_resource($conms))
  	mysqli_close($conms);
  // echo '--dis-connected--';
}

function skyMysqlQuery($sql){
	global $conms;
	if (!is_resource($conms))
		connectDB();
	$sql = skyFilter($sql);
	$result = mysqli_query($conms,$sql);
	return $result;
}
/*
* Get Single Record with row number
*			echo $row[0];
*/
function skyMysqlRow($sql){
	return mysqli_fetch_row(skyMysqlQuery($sql));
}

/*
* Get Single Record with assoc
*					echo $row["userid"];
*/
function skyMysqlAssoc($sql){
	return mysqli_fetch_assoc(skyMysqlQuery($sql));
}

/*
* Get Single Record with object name
*			echo $row->user_id;
*/
function skyMysqlObject($sql){
	return mysqli_fetch_object(skyMysqlQuery($sql));
}

/*
* return value of selected field for passed id
*/
function skyGetNameById($tableName,$fieldName,$id)
{
	$sql = 'SELECT '.$fieldName.' FROM '.$tableName.' WHERE id="'.$id.'"';
	$rowName = mysqli_fetch_object(skyMysqlQuery($sql));
	return $rowName->$fieldName;
}

function skyGetNameByFind($tableName,$name)
{
	$sql = skyMysqlQuery('SELECT * FROM '.$tableName.' WHERE name="'.myUser::dospace($name).'"');
	$rowName = mysqli_fetch_object($sql);
	return $rowName->name;
}

function skyGetRecordById($tableName,$id)
{
	$sql = 'SELECT * FROM '.$tableName.' WHERE id='.$id;
	return mysqli_fetch_object(skyMysqlQuery($sql));
}

function skyGetRecordBySlug($tableName, $name)
{
	$sql = 'SELECT * FROM '.$tableName.' WHERE slug="'.$name.'"';
	return mysqli_fetch_object(skyMysqlQuery($sql));
}

function skyGetRecordByName($tableName, $where, $name)
{
	$sql = 'SELECT * FROM '.$tableName.' WHERE '.$where.' like "%'.str_replace(' ','%', myUser::dospace($name)).'%"';
	return mysqli_fetch_object(skyMysqlQuery($sql));
}

function skyGetListById($id, $child="")
{
    if($child){
        $sql = skyMysqlQuery('select * from category where status!="B" and parents like "%|'.$id.'|"'.' order by id desc');
        while($val =  mysqli_fetch_object($sql)){
            $data[] = $val;
            foreach(skyGetListById($val->id, $val->child) as $val){
                $data[] = $val;
            }
        }
        return $data;
    }
    else{
        $sql = skyMysqlQuery('select * from files where status!="B" and category_id='.$id.' order by ord asc, id desc');
        while($val =  mysqli_fetch_object($sql)){
            $data[] = $val;
        }
        return $data;
    }
}

function skyGetListAll($list){
    if($list->parents=='|') $data[] = $list;
    
        $sql = skyMysqlQuery('select * from category where status!="B" and parents like "%|'.$list->id.'|"'.' order by ord asc, id desc');
        while($value =  mysqli_fetch_object($sql)){
            $data[] = $value;
            foreach(skyGetListAll($value) as $val)
                $data[] = $val;
        }
        return $data;
}

function skyGetListFiles($id){
    $sql = skyMysqlQuery('select * from files where status!="B" and category_id='.$id.' order by id desc');
    while($files = mysqli_fetch_object($sql)){
        $data[] = $files;
    }
    return $data;
}


function skyFilter($sql)
{
	$words = array("union ","information_schema","mysqli.user","from admin");
	return str_replace($words,'',$sql);
}


function skyMysqlCount($tableName,$criteria='')
{
	$sql = 'SELECT count(*) FROM '.$tableName;
	if($criteria)
		$sql .= ' WHERE '.$criteria;
	$rs = mysqli_fetch_row(skyMysqlQuery($sql));
	return $rs[0];
}


function skyMysqlGetCount($sql,$asitis=false)
{
	if($asitis==false){
		$sql = preg_replace('/select (\*|.*) from /','select count(id) from ',$sql);
		$rs = mysqli_fetch_row(skyMysqlQuery($sql));
		return $rs[0];
	}
	else{
		$rs = mysqli_num_rows(skyMysqlQuery($sql));
		return $rs;
	}
}

/*
* This function return start limit for mysql
*		arguments (totalRecordCount, current page, resultPerPage)
*		return Start Value
*/
function skyGetStartLimit($total, $page, $perpage){
	if((($page-1) * $perpage) >= $total)
		return (floor($total - $perpage) > -1) ? floor($total - $perpage) : 0 ;
	else
		return (($page-1) * $perpage);
}


function mysqlEscapeString($v){
    global $conms;
    return mysqli_real_escape_string($conms, $v);
}

/*
* SKYiTECH:: return formatted date
*/
function skyDate($format, $time){
	return date($format, strtotime($time));
}


/*
* call this function once before calling getCountry() function
*/
global $getCountryByIpClass;
function skyEnableCountryClass(){
	global $getCountryByIpClass;
	include "include/ipclass.php";
	$getCountryByIpClass = new get_user_info;
}
/*
* skyitech:: get country name by ip
*/
function skyGetCountry($ip=''){
	global $getCountryByIpClass;
	if(!$ip)
		$ip=$_SERVER['REMOTE_ADDR'];
	$getCountryByIpClass->set_ip($ip);
	$getCountryByIpClass->dist_ip();
	$getCountryByIpClass->count_ip();
	$info = $getCountryByIpClass->search_country();
	return $info['2letters_country'];
}

?>