-- phpMyAdmin SQL Dump
-- version 4.9.7
-- https://www.phpmyadmin.net/
--
-- Host: localhost:3306
-- Generation Time: Apr 24, 2022 at 07:51 PM
-- Server version: 5.7.37
-- PHP Version: 7.4.27

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+05:30";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `santavur_db`
--

-- --------------------------------------------------------

--
-- Table structure for table `admin`
--

CREATE TABLE `admin` (
  `id` int(11) NOT NULL,
  `username` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `password` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `level` int(1) NOT NULL,
  `is_superadmin` varchar(1) COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `admin`
--

INSERT INTO `admin` (`id`, `username`, `password`, `level`, `is_superadmin`) VALUES
(1, 'admin', '21232f297a57a5a743894a0e4a801fc3', 1, 'Y');

-- --------------------------------------------------------

--
-- Table structure for table `artist`
--

CREATE TABLE `artist` (
  `id` int(11) NOT NULL,
  `name` varchar(100) COLLATE utf8_unicode_ci DEFAULT NULL,
  `status` text COLLATE utf8_unicode_ci NOT NULL,
  `description` text COLLATE utf8_unicode_ci
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `category`
--

CREATE TABLE `category` (
  `id` int(11) NOT NULL,
  `category_name` varchar(100) COLLATE utf8_unicode_ci DEFAULT NULL,
  `title` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `description` text COLLATE utf8_unicode_ci,
  `parents` varchar(100) COLLATE utf8_unicode_ci DEFAULT '|',
  `parentsarray` text COLLATE utf8_unicode_ci,
  `status` varchar(1) COLLATE utf8_unicode_ci DEFAULT 'A',
  `child` varchar(1) COLLATE utf8_unicode_ci DEFAULT 'N',
  `list_ord` int(1) DEFAULT '0',
  `ord` int(4) DEFAULT '0',
  `flag_new` int(2) DEFAULT '0',
  `flag_updated` int(2) DEFAULT '0',
  `flag_hot` int(2) DEFAULT '0',
  `files` int(5) DEFAULT '0',
  `url` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `type` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `label` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `music` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `remixer` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `download_history`
--

CREATE TABLE `download_history` (
  `id` int(11) NOT NULL,
  `date` varchar(8) DEFAULT NULL,
  `file_id` int(11) DEFAULT NULL,
  `extension` varchar(4) DEFAULT NULL,
  `hits` int(5) DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `files`
--

CREATE TABLE `files` (
  `id` int(11) NOT NULL,
  `file_name` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `category_id` int(11) DEFAULT '0',
  `description` text COLLATE utf8_unicode_ci,
  `singer` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `tags` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `size` int(9) DEFAULT '0',
  `today` int(5) DEFAULT '0',
  `download` int(6) DEFAULT '0',
  `extension` varchar(4) COLLATE utf8_unicode_ci DEFAULT NULL,
  `ord` int(4) DEFAULT '0',
  `status` varchar(1) COLLATE utf8_unicode_ci DEFAULT 'A',
  `url` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `label` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `music` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `remixer` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `embed` text COLLATE utf8_unicode_ci
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `log_history`
--

CREATE TABLE `log_history` (
  `id` int(11) NOT NULL,
  `date` int(8) DEFAULT '0',
  `host` int(6) DEFAULT '0',
  `hits` int(6) DEFAULT '0',
  `download` int(8) DEFAULT '0',
  `files` varchar(255) COLLATE utf8_unicode_ci DEFAULT '|'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `search`
--

CREATE TABLE `search` (
  `id` int(11) NOT NULL,
  `tag` varchar(50) COLLATE utf8_unicode_ci DEFAULT NULL,
  `hits` int(5) DEFAULT '1'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `setting`
--

CREATE TABLE `setting` (
  `id` int(11) NOT NULL,
  `meta` varchar(40) COLLATE utf8_unicode_ci DEFAULT NULL,
  `description` varchar(100) COLLATE utf8_unicode_ci DEFAULT NULL,
  `value` text COLLATE utf8_unicode_ci,
  `device` varchar(1) COLLATE utf8_unicode_ci DEFAULT 'P',
  `updated_at` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `setting`
--

INSERT INTO `setting` (`id`, `meta`, `description`, `value`, `device`, `updated_at`) VALUES
(1, 'TITLE', '', NULL, 'P', '2021-06-19 10:49:05'),
(2, 'THUMB_DOMAIN', '', '/siteuploads/thumb', 'P', '2017-12-01 10:56:40'),
(3, 'ONLINE_COUNTER', 'VALUE=ON, OFF', 'OFF', 'P', '2017-01-05 12:29:47'),
(4, 'CATEGORY_PER_PAGE', '', '16', 'P', '2022-04-24 18:36:28'),
(5, 'FILES_PER_PAGE', '', '16', 'P', '2022-04-23 22:00:44'),
(6, 'ADVT_AFTER_EACH_FILES', '', '3', 'P', '2016-09-30 15:46:09'),
(7, 'MOB_DATA_DOMAIN', '', '/siteuploads', 'P', '2017-12-01 10:56:23'),
(9, 'PC_DATA_DOMAIN', '', '/siteuploads', 'P', '2017-12-01 10:56:31'),
(10, 'FEATURED_FILES', '', '4', 'P', '2022-04-24 17:03:55'),
(11, 'WALLPAPER_SIZE', '', '128x160,176x220,240x320,,240x400,320x240,320x480,,360x640,480x320,480x800,,640x480,720x1280,960x800,,1080x960,1440x1280', 'P', '2016-09-30 15:47:41'),
(12, 'SEARCH_TYPE', 'VALUE= CAT,EXT', 'EXT', 'P', '2016-09-30 16:50:55'),
(13, 'SEARCH_EXTENSIONS', '', 'JPG,3GP,MP3,MP4', 'P', '2016-09-30 15:48:56'),
(14, 'ONLINE_SHOW_COUNT', 'VALUE= ON,OFF', 'OFF', 'P', '2017-01-05 12:29:39'),
(16, 'THUMB_CAT_TOP', '', '3', 'P', '2021-10-10 14:19:06'),
(17, 'THUMB_CAT_LIST', '', '3', 'P', '2022-04-23 21:51:46'),
(18, 'THUMB_FILE_LIST', '', '3', 'P', '2022-04-23 21:52:10'),
(19, 'THUMB_FILE_TOP', '', '3', 'P', '2017-01-19 05:19:12'),
(20, 'WALLPAPER_WATERMARK', 'VALUE= ON,OFF', 'ON', 'P', '2016-09-30 16:43:49'),
(22, 'LATEST_FILES', 'VALUE= 0,50', '10', 'P', '2021-10-04 05:04:53'),
(23, 'LATEST_FILES_LIST', '', 'ON', 'P', '2017-01-18 09:17:00'),
(24, 'TITLE_HOME', ' ', '- New Latest Mp3 Songs Download', 'P', '2021-06-19 10:48:55'),
(55, 'THUMB_ARTIST_LIST', '', '3', 'P', '2022-04-23 21:51:57'),
(25, 'ARTIST_PER_PAGE', '', '10', 'P', '2016-09-30 16:28:00'),
(26, 'MP3TAG_OVERWRITE', 'VALUE= ON,OFF', 'ON', 'A', '2016-09-30 16:37:52'),
(27, 'TITLE', ' ', NULL, 'M', '2017-08-31 23:53:07'),
(28, 'THUMB_DOMAIN', '', '/siteuploads/thumb', 'M', '2017-12-01 10:56:13'),
(29, 'ONLINE_COUNTER', 'VALUE=ON, OFF', 'OFF', 'M', '2017-01-05 12:25:16'),
(30, 'CATEGORY_PER_PAGE', '', '12', 'M', '2022-04-24 18:36:18'),
(31, 'FILES_PER_PAGE', '', '12', 'M', '2022-04-23 22:01:25'),
(32, 'ADVT_AFTER_EACH_FILES', '', '3', 'M', '2016-09-30 15:46:09'),
(33, 'MOB_DATA_DOMAIN', '', '/siteuploads', 'M', '2017-12-01 10:55:55'),
(35, 'PC_DATA_DOMAIN', '', '/siteuploads', 'M', '2017-12-01 10:56:05'),
(36, 'FEATURED_FILES', '', '4', 'M', '2022-04-24 17:04:03'),
(37, 'WALLPAPER_SIZE', '', '128x160,176x220,240x320,,240x400,320x240,320x480,,360x640,480x320,480x800,,640x480,720x1280,960x800,,1080x960,1440x1280', 'M', '2016-09-30 15:47:41'),
(38, 'SEARCH_TYPE', 'VALUE= CAT,EXT', 'EXT', 'M', '2016-09-30 16:50:55'),
(39, 'SEARCH_EXTENSIONS', '', 'JPG,3GP,MP3,MP4', 'M', '2016-09-30 15:48:56'),
(40, 'ONLINE_SHOW_COUNT', 'VALUE= ON,OFF', 'ON', 'M', '2017-01-05 12:25:23'),
(42, 'THUMB_CAT_TOP', '', '3', 'M', '2021-10-10 14:19:29'),
(43, 'THUMB_CAT_LIST', '', '3', 'M', '2022-04-23 21:51:29'),
(44, 'THUMB_FILE_LIST', '', '3', 'M', '2022-04-23 21:51:17'),
(45, 'THUMB_FILE_TOP', '', '3', 'M', '2021-10-10 14:19:42'),
(46, 'THUMB_ARTIST_LIST', '', '3', 'M', '2022-04-23 21:52:13'),
(47, 'WALLPAPER_WATERMARK', 'VALUE= ON,OFF', 'ON', 'M', '2016-09-30 16:43:49'),
(49, 'LATEST_FILES', 'VALUE= 0,50', '6', 'M', '2021-10-04 04:58:41'),
(50, 'LATEST_FILES_LIST', '', 'ON', 'M', '2017-01-18 09:16:43'),
(51, 'TITLE_HOME', ' ', '- New Latest Mp3 Songs Download', 'M', '2021-06-19 11:06:48'),
(52, 'ARTIST_PER_PAGE', '', '10', 'M', '2016-09-30 16:28:00');

-- --------------------------------------------------------

--
-- Table structure for table `updates`
--

CREATE TABLE `updates` (
  `id` int(11) NOT NULL,
  `description` text COLLATE utf8_unicode_ci,
  `status` varchar(1) COLLATE utf8_unicode_ci DEFAULT 'A',
  `created_at` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `updates_app`
--

CREATE TABLE `updates_app` (
  `id` int(11) NOT NULL,
  `title` varchar(250) COLLATE utf8_unicode_ci DEFAULT NULL,
  `description` varchar(250) COLLATE utf8_unicode_ci DEFAULT NULL,
  `tid` int(11) DEFAULT NULL,
  `type` varchar(1) COLLATE utf8_unicode_ci DEFAULT 'c',
  `thumb` varchar(250) COLLATE utf8_unicode_ci DEFAULT NULL,
  `status` varchar(1) COLLATE utf8_unicode_ci DEFAULT 'A',
  `created_at` datetime DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `admin`
--
ALTER TABLE `admin`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `artist`
--
ALTER TABLE `artist`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `an` (`name`);

--
-- Indexes for table `category`
--
ALTER TABLE `category`
  ADD PRIMARY KEY (`id`),
  ADD KEY `category_parents_index` (`parents`);

--
-- Indexes for table `download_history`
--
ALTER TABLE `download_history`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `df` (`date`,`file_id`),
  ADD KEY `download_history_date_index` (`date`),
  ADD KEY `download_history_FI_1` (`file_id`);

--
-- Indexes for table `files`
--
ALTER TABLE `files`
  ADD PRIMARY KEY (`id`),
  ADD KEY `files_file_name_index` (`file_name`),
  ADD KEY `files_category_id_index` (`category_id`);

--
-- Indexes for table `log_history`
--
ALTER TABLE `log_history`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `search`
--
ALTER TABLE `search`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `df` (`tag`);

--
-- Indexes for table `setting`
--
ALTER TABLE `setting`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `updates`
--
ALTER TABLE `updates`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `updates_app`
--
ALTER TABLE `updates_app`
  ADD PRIMARY KEY (`id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `admin`
--
ALTER TABLE `admin`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

--
-- AUTO_INCREMENT for table `artist`
--
ALTER TABLE `artist`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `category`
--
ALTER TABLE `category`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `download_history`
--
ALTER TABLE `download_history`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `files`
--
ALTER TABLE `files`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `log_history`
--
ALTER TABLE `log_history`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `search`
--
ALTER TABLE `search`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `setting`
--
ALTER TABLE `setting`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=56;

--
-- AUTO_INCREMENT for table `updates`
--
ALTER TABLE `updates`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `updates_app`
--
ALTER TABLE `updates_app`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
