<?php
error_reporting(0);
session_name('SKYiTech');
@session_start();

if($_SESSION['symfony/user/sfUser/authenticated']!=1 && !$_REQUEST['multi']){
	header('Location: /');
	exit;
}

$TaggingFormat = 'UTF-8';
header('Content-Type: text/html; charset='.$TaggingFormat);

require_once('getid3/getid3.php');
//include('config.php');
// Initialize getID3 engine
$getID3 = new getID3;
$getID3->setOption(array('encoding'=>$TaggingFormat));

getid3_lib::IncludeDependency(GETID3_INCLUDEPATH.'write.php', __FILE__, true);

function FixTextFields($text) {
	return htmlentities(getid3_lib::SafeStripSlashes($text), ENT_QUOTES);
}

$Filename = '../siteuploads/files/'.(isset($_REQUEST['Filename']) ? getid3_lib::SafeStripSlashes($_REQUEST['Filename']) : '');

{
	//$TagFormatsToWrite = (isset($_POST['TagFormatsToWrite']) ? $_POST['TagFormatsToWrite'] : array());
	$TagFormatsToWrite = Array('id3v1','id3v2.3','ape');
	if (!empty($TagFormatsToWrite)) {
		//echo 'starting to write tag(s)<BR>';

		$tagwriter = new getid3_writetags;
		$tagwriter->filename       = $Filename;
		$tagwriter->tagformats     = $TagFormatsToWrite;
		$tagwriter->overwrite_tags = true;
		$tagwriter->tag_encoding   = $TaggingFormat;
		//if (!empty($_POST['remove_other_tags']))
		{
			$tagwriter->remove_other_tags = true;
		}
        
		date_default_timezone_set('Asia/Kolkata');
        $mysite = $_REQUEST['sitename'];
		$commonkeysarray = array(
        'Title'			    =>	substr(base64_decode($_REQUEST['lastFile']),0,-4),
        'Artist'		    =>	$_REQUEST['singer'] ? base64_decode($_REQUEST['singer']) : $mysite,
        'Album'			    =>	base64_decode($_REQUEST['catName']).' - '.$mysite,
        'Year'			    =>	$_REQUEST['year'] ? $_REQUEST['year'] : date("Y"),
        'Comment'		    =>	'Downloaded from http://'.strtolower($mysite),
        'Composer'	        =>	$_REQUEST['composer'] ? $_REQUEST['composer'] : $mysite,
        'Band'			    =>	$_REQUEST['band'] ? $_REQUEST['band'] : $mysite,
        'original_artist'   =>	$_REQUEST['og_artist'] ? $_REQUEST['og_artist'] : $mysite,
        'Publisher'	        =>	$_REQUEST['publisher'] ? $_REQUEST['publisher'] : $mysite,
        'Conductors'		=>	$_REQUEST['conductors'] ? $_REQUEST['conductors'] : $mysite,
        'Track'		        =>	$_REQUEST['track'] ? $_REQUEST['track'] : '',
        'Group description'	=>	$mysite,
        'Gener'		        =>	$mysite,
        'Part of set'		=>	$mysite,
        'Initial key'		=>	$mysite,
        'Album artist'	    =>	$artist,
        'Copyright'	    	=>	$mysite,
        'Author URL'		=>	'https://'.strtolower($mysite),
									);

		foreach ($commonkeysarray as $key => $value) {
			if ($value){ $TagData[strtolower($key)][] = getid3_lib::SafeStripSlashes($value); }
		}

		if($_REQUEST['filethumb']){
			$thumbImg = '../siteuploads/thumb/'.$_REQUEST['filethumb'];
		}
		elseif($_REQUEST['cid'] && is_file('../siteuploads/thumb/c/'.$_REQUEST['cid'].'_6.jpg')){
			$thumbImg = '../siteuploads/thumb/c/'.$_REQUEST['cid'].'_6.jpg';
		} else $thumbImg = '../images/albumart.jpg';
        
		if (is_file($thumbImg)) {
			if (in_array('id3v2.4', $tagwriter->tagformats) || in_array('id3v2.3', $tagwriter->tagformats) || in_array('id3v2.2', $tagwriter->tagformats)) {

					if ($fd = @fopen($thumbImg, 'rb')) {
						$APICdata = fread($fd, filesize($thumbImg));
						fclose ($fd);

						//list($APIC_width, $APIC_height, $APIC_imageTypeID) = GetImageSize($_FILES['userfile']['tmp_name']);
						list($APIC_width, $APIC_height, $APIC_imageTypeID) = GetImageSize($thumbImg);
						$imagetypes = array(1=>'gif', 2=>'jpeg', 3=>'png');
						if (isset($imagetypes[$APIC_imageTypeID])) {
							$TagData['attached_picture'][0]['data']          = $APICdata;
							$TagData['attached_picture'][0]['picturetypeid'] = 3;
							$TagData['attached_picture'][0]['description']   = $thumbImg;
							$TagData['attached_picture'][0]['mime']          = 'image/'.$imagetypes[$APIC_imageTypeID];
						}
					}
			}
		}

		$tagwriter->tag_data = $TagData;
		if ($tagwriter->WriteTags()) {
			/*
			* SKYiTech :: if file uploaded via multiple upload or dir upload just reply identification code
			*/
			if(@$_REQUEST['dirCatch']){
				echo $_REQUEST['dirCatch'];
				exit;
			}
			//echo 'Successfully wrote tags<BR>';
			
			/*
			* SKYiTech :: if single file uploaded redirect to upload page again.
			*/
			$goto = 'files/create/cid/'.$_REQUEST['cid'].'/lastFile/'.$_REQUEST['lastFile'].'/status/'.$_REQUEST['status'];
			if($_REQUEST['cid'] && !$_REQUEST['multi'])
				header('Location: '.$goto);

			// print warning
			//if (!empty($tagwriter->warnings))
			{
				//echo 'There were some warnings:<BLOCKQUOTE STYLE="background-color:#FFCC33; padding: 10px;">'.implode('<BR><BR>', $tagwriter->warnings).'</BLOCKQUOTE>';
			}
		} else {
			echo 'Failed to write tags!<BLOCKQUOTE STYLE="background-color:#FF9999; padding: 10px;">'.implode('<BR><BR>', $tagwriter->errors).'</BLOCKQUOTE>';
		}
	} else {
		echo 'WARNING: no tag formats selected for writing - nothing written';
	}
	echo '<script type="text/javascript"> document.title="Mp3 Tag Writer Success"; </script>';
}
?>