<?php
date_default_timezone_set("Asia/Kolkata");
$sitemap="sitemap.xml";
$siteurl=$_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['HTTP_HOST'];
$phpself=$_SERVER['PHP_SELF'];
$limited=50000;      //Sitemap Links Limit
$priority="0.8";     //change priority any one:- 0.5, 0.80
$changefreq="daily"; //change freq any one:- always, Hourly, daily, weekly, monthly, yearly, never
$other_Links=[
"/disclaimer.html",
"/privacy-policy.html"
];
foreach($other_Links as $urlLink){
if($urlLink){
$url.="<url>
<loc>".$siteurl.$urlLink."</loc>
<lastmod>".date('c', time())."</lastmod>
<changefreq>never</changefreq>
<priority>0.5</priority>
</url>\n";
}
}

$category = skyMysqlQuery("select * from category where status='A' order by ord asc, id desc");

while($value = mysqli_fetch_object($category)):
    if($value->child=='D'):
$url.="<url>
<loc>".url_for('/category/list/?parent='.$value->id.'&fname='.myUser::slugify($value->category_name))."</loc>
<lastmod>".date('c', time())."</lastmod>
<changefreq>".$changefreq."</changefreq>
<priority>".$priority."</priority>
</url>\n";
endif;
endwhile;
$fList = skyMysqlQuery('select * from files where status!="B" order by id desc');
while($files = mysqli_fetch_object($fList)):
$date=explode(" ", $files->created_at);
$lastmod=$date[0]."T".$date[1]."+05:30";
$url.="<url>
<loc>".url_for('@filesShow?id='.$files->id.'&name='.myUser::slugify( myUser::fileName($files->file_name,false)))."</loc>
<lastmod>".$lastmod."</lastmod>
<changefreq>".$changefreq."</changefreq>
<priority>0.9</priority>
</url>\n";
endwhile;
$head="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" .
"<?xml-stylesheet type=\"text/xsl\" href=\"/css/sitemap.xsl\"?>\n" .
 "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\"\n" .
                 "        xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n" .
                 "        xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9\n" .
                 "        http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\">
<url>
<loc>".$siteurl."/</loc>
<lastmod>".date('c', time())."</lastmod>
<changefreq>".$changefreq."</changefreq>
<priority>1.0</priority>
</url>\n";
$end="</urlset>";
$albumList = skyMysqlQuery('select * from category where child="F" or child="N" order by id desc');
while($album = mysqli_fetch_object($albumList)):
$albumName = str_replace('&', ',', $album->category_name);
$url.="<url>
<loc>".url_for('@filesList?parent='.$album->id.'&fname='.myUser::slugify($album->category_name).'&sort='.myUser::getListOrd($album->list_ord))."</loc>
<lastmod>".date('c', time())."</lastmod>
<changefreq>".$changefreq."</changefreq>
<priority>".$priority."</priority>
</url>\n";
endwhile;
$singerList = skyMysqlQuery('select * from artist where status!="B" order by name asc');
while($singer = mysqli_fetch_object($singerList)):
$url.="<url>
<loc>".url_for('@filesSingerList?singer='.myUser::slugify($singer->name))."</loc>
<lastmod>".date('c', time())."</lastmod>
<changefreq>".$changefreq."</changefreq>
<priority>0.6</priority>
</url>\n";
endwhile;
$write=$head.$url.$end;
@unlink($sitemap);
if (file_exists($sitemap)) {
  $fh = fopen($sitemap, 'a');
  fwrite($fh, $write);
} else {
  $fh = fopen($sitemap, 'w');
  fwrite($fh, $write);
}
fclose($fh);

// PING SITEMAP TO SEARCH ENGINES
$google="https://www.google.com/webmasters/tools/ping?sitemap=";
$ch = curl_init(); 
            curl_setopt($ch, CURLOPT_URL, $google.$siteurl."/".$sitemap); 
            curl_setopt($ch, CURLOPT_HEADER, TRUE);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE); 
            $head = curl_exec($ch); 
            $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE); 
            curl_close($ch);
if($httpCode==200){
echo '<div class="finfo tCenter"><b>Sitemap Successfully Generated</b>
<p class="home"><a href="/'.$sitemap.'"><b>View Your Sitemap.xml</b></a></p>
</div>';
}
 ?>
